LO=0.4; //Loch-Offset
xyLuefterKantenlaenge=40;
dLuefterflansch=2;
dSchraubeLuefter=3.2+LO;
xyAbstandSchraubeRand=4;
dRotor=32+LO;
hBohr=100;
xRect=30;
yRect=12;
L1=50;  //Länge der Düse
fn1=18;
fn2=72;

module stick_v(x1,y1,z1, x2,y2,z2, d){
	r=d/2;
	polyhedron( points=[
		[x1-r, y1-r, z1],    //0
		[x2-r, y2-r, z2],    //1	
		[x1+d-r, y1-r, z1],      //2
		[x2+d-r, y2-r, z2],      //3
		[x1-r, y1+d-r, z1],  //4
		[x2-r, y2+d-r, z2],	//5
		[x1+d-r, y1+d-r, z1],	  //6
		[x2+d-r, y2+d-r, z2]    //7
	], faces = [
		//bottom (Counterclockwise)
		[0, 1, 4],
		[4, 1, 5],
		//front
		[3, 1, 0],
		[0, 2, 3],
		//back (Counterclockwise)
		[4, 5,7],
		[7, 6, 4],
		//top
		[7, 3,2],
		[2, 6, 7],
		//left (start)
		[2, 0, 4],
		[4, 6, 2],
		//right (end)
		[1, 3, 7],
		[7, 5, 1]
	]);
}

difference(){ 	//Flansch mit 4 Bohrungen
	translate([-xyLuefterKantenlaenge/2,-xyLuefterKantenlaenge/2,-0.1])
		cube([xyLuefterKantenlaenge,xyLuefterKantenlaenge,dLuefterflansch]);
	for ( a = [90 : 90: 360] )
	rotate([0,0,a])
		translate([xyLuefterKantenlaenge/2 - xyAbstandSchraubeRand, xyLuefterKantenlaenge/2  - xyAbstandSchraubeRand,-0.1])
			cylinder(d=dSchraubeLuefter,h=hBohr,$fn=fn1);
	cylinder(d=dRotor,h=hBohr,center=true, $fn=fn2);
			
}

module circleToRect(dCircle, aRect, bRect, height, bOffset, thickness){
	q1=45+90;
	q2=q1+90;
	q3=q2+90;
	q4=q3+90;
union(){
	for ( a = [45 : 10: 360+45] ){
		
		if (a < q1){
			color("red")
			stick_v(sin(a) * dCircle/2, cos(a) * dCircle/2, 0,  	 aRect/2, bOffset+	0-(a-q1)/90 * bRect-bRect/2, height, thickness);
		}
		else if (a < q2){
	 		color("green")
			stick_v(sin(a) * dCircle/2, cos(a) * dCircle/2, 0, 	 -(a-q2)/90 * aRect-aRect/2, bOffset-bRect/2,			 height, thickness);
		}
		else if (a < q3){
	 		color("blue")
			stick_v(sin(a) * dCircle/2, cos(a) * dCircle/2, 0,	 	-aRect/2, bOffset+(a-q3)/90 * bRect+bRect/2 ,				 height, thickness);
		}
		else{
	 		color("orange")
	  	  	stick_v(sin(a) * dCircle/2, cos(a) * dCircle/2, 0,	 	(a-q4)/90 * aRect+aRect/2, 	 bOffset+bRect/2, 			 height, thickness);
		}
	
	}
}
}
//	circleToRect(dRotor+2,60,10, 50/2+0,1.2);
translate([0,0,dLuefterflansch])
difference(){
	hull(){

		circleToRect(dCircle=dRotor+4, aRect=60, bRect=10, height=L1, bOffset=29, thickness=1);
	}
	hull(){
		translate([0,0,-0.01])
		circleToRect(dCircle=dRotor-1, aRect=60-4,bRect=10-2.5, height=L1+0.02, bOffset=29.5, thickness=1);
	}

	translate([-50,0,95])
	rotate ([-60,0,0])
	cube([100,100,50]);
}


//circleToSquare(40,40*sqrt(3.1415926 / 4),1);
//stick_v(0,0,0, 0,0,10, 2);
